-- name: Kuribo Challenge 64!
-- description: Everything is achievable, even when you're stuck in a shoe! Give yourself a little challenge and collect as many stars as you can by hopping around as a\\#A04800\\ Goomba\\#dcdcdc\\ in his Iconic\\#0AC11B\\ Green Shoe\\#dcdcdc\\! \n\n\\#ff7777\\Requires Character Select\nto use!

if not _G.charSelectExists then return end

local E_MODEL_KURIBO = smlua_model_util_get_id("kgoomba_geo")

local TEX_KURIBO_ICON = get_texture_info("kuribotex")

local TEXT_MOD_NAME = "Kuribo Challenge 64!"

local VOICETABLE_GOOMBA = {
    [CHAR_SOUND_YAH_WAH_HOO] = 'MW_Jump.ogg',
    [CHAR_SOUND_HOOHOO] = 'MW_Jump.ogg',
    [CHAR_SOUND_YAHOO] = 'MW_Jump2.ogg',
    [CHAR_SOUND_UH] = 'Guh2coughing2.ogg',
    [CHAR_SOUND_HRMM] = 'Ghrm.ogg',
    [CHAR_SOUND_WAH2] = 'Gwah.ogg',
    [CHAR_SOUND_WHOA] = 'Gwhoa.ogg',
    [CHAR_SOUND_EEUH] = 'Geeuh.ogg',
    [CHAR_SOUND_ATTACKED] = 'Gattacked.ogg',
    [CHAR_SOUND_OOOF] = 'Gooof.ogg',
    [CHAR_SOUND_OOOF2] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'Ghere we go.ogg',
    [CHAR_SOUND_YAWNING] = 'Gyawning.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'Gwaaaooow.ogg',
    [CHAR_SOUND_HAHA] = 'Ghaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'Ghaha.ogg',
    [CHAR_SOUND_UH2] = 'Guh.ogg',
    [CHAR_SOUND_UH2_2] = 'Guh2_2.ogg',
    [CHAR_SOUND_ON_FIRE] = 'Gfire.ogg',
    [CHAR_SOUND_DYING] = 'Gdying.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_PANTING] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_COUGHING1] = 'Gcoughing.ogg',
    [CHAR_SOUND_COUGHING2] = 'Guh2coughing2.ogg',
    [CHAR_SOUND_COUGHING3] = 'Gooof2pantingcoughing3.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'Gyah (2).ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'MW_Jump2.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'Gsurprise.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'Gwah.ogg',
    [CHAR_SOUND_DROWNING] = 'Gdrowning.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'Gwah_punch.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'MW_Jump2.ogg',
    [CHAR_SOUND_DOH] = 'Gdoh.ogg',
    [CHAR_SOUND_HELLO] = 'Ghello.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'Gquestion.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'Gsolongabowser.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'Gimatired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'Gletsago.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'Goki doki.ogg',
}

local PALETTE_KURIBO = {
    [PANTS]  = "0AC11B",
    [SHIRT]  = "BAB005",
    [GLOVES] = "686868",
    [SHOES]  = "AFA750",
    [SKIN]   = "A04800",
    [CAP]    = "4D391D",
}

local capKuribo = {
    normal = smlua_model_util_get_id("kgoombas_cap_geo"),
    wing = smlua_model_util_get_id("kgoombas_wing_cap_geo"),
    metal = smlua_model_util_get_id("kgoombas_metal_cap_geo"),
    metalWing = smlua_model_util_get_id("kgoombas_metal_wing_cap_geo")
}

if not _G.charSelectExists then
    djui_popup_create(
    "\\#ffffdc\\\n" ..
    TEXT_MOD_NAME ..
    "\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!",
        6)
    return
end

if _G.charSelectExists then
    CT_KURIBO = _G.charSelect.character_add("Kuribo's Shoe Goomba", "'That ungrateful Big Fat Green Chain-Chomp Look-a-like!', cursed Jeremiah. 'You know what?! I'm glad he fired me anyway. He doesn't see every possible capabilities that I can do with this thing. Oh, but I'll make him see it, alright. I'LL MAKE EVERYONE SEE!!'", "PakPecik", "A04800", E_MODEL_KURIBO, CT_MARIO, TEX_KURIBO_ICON)

    _G.charSelect.character_add_caps(E_MODEL_KURIBO, capKuribo)
    _G.charSelect.character_add_palette_preset(E_MODEL_KURIBO, PALETTE_KURIBO)
    -- the following must be hooked for each character added
    _G.charSelect.character_add_voice(E_MODEL_KURIBO, VOICETABLE_GOOMBA)
    hook_event(HOOK_CHARACTER_SOUND, function(m, sound)
        local v = _G.charSelect.character_get_voice(m)
        if not v then return end
        if v == VOICETABLE_GOOMBA then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function(m)
        local v = _G.charSelect.character_get_voice(m)
        if not v then return end
        if v == VOICETABLE_GOOMBA then return _G.charSelect.voice.snore(m) end
    end)

    local myCharPlacement = _G.charSelect.character_get_number_from_string("Kuribo's Shoe Goomba")

    local function mario_before_phys_step(m)
        if m.playerIndex == 0 then
            if myCharPlacement == _G.charSelect.character_get_current_number("Kuribo's Shoe Goomba") then
                gPlayerSyncTable[m.playerIndex].charMoveset = true
            else
                gPlayerSyncTable[m.playerIndex].charMoveset = false
            end
        end
        
        if gPlayerSyncTable[m.playerIndex].charMoveset then
            local hScale = 1.0
            local vScale = 1.0

            --Speed floor
            if m.action == ACT_WALKING or m.action == ACT_HOLD_WALKING or m.action == ACT_METAL_WATER_WALKING or m.action == ACT_HOLD_METAL_WATER_WALKING or m.action == ACT_HOLD_HEAVY_WALKING then
                mario_set_forward_vel(m, 0)
            end
            
            --sound when walking
            if m.action == ACT_WALKING or m.action == ACT_HOLD_WALKING or m.action == ACT_HOLD_HEAVY_WALKING then
                play_sound(SOUND_AIR_AMP_BUZZ, m.marioObj.header.gfx.cameraToObject)
                set_mario_particle_flags(m, PARTICLE_MIST_CIRCLE, 0)
            end
            
            -- fixes the momentum bug
            if (m.action == ACT_HOLD_WATER_JUMP) then
                return
            end

            -- make goomba sink
            if (m.action & ACT_FLAG_SWIMMING) ~= 0 then
                if m.action ~= ACT_BACKWARD_WATER_KB and
                    m.action ~= ACT_FORWARD_WATER_KB and
                    m.action ~= ACT_WATER_PLUNGE then
                    m.vel.y = m.vel.y - 10
                end
            end

            -- f@$% quicksand >:(
            if (m.action & ACT_IN_QUICKSAND) ~= 0 then
                if m.action ~= ACT_QUICKSAND_DEATH then
                    m.quicksandDepth = 0
                end
            end

            m.vel.x = m.vel.x * hScale
            m.vel.z = m.vel.z * hScale
        end
    end
    hook_event(HOOK_BEFORE_PHYS_STEP, mario_before_phys_step)

    local function mario_update(m)
        if m.playerIndex == 0 then
            if myCharPlacement == _G.charSelect.character_get_current_number("Kuribo's Shoe Goomba") then
                gPlayerSyncTable[m.playerIndex].charMoveset = true
            else
                gPlayerSyncTable[m.playerIndex].charMoveset = false
            end
        end
        
        if gPlayerSyncTable[m.playerIndex].charMoveset then

            -- f@$% quicksand >:( (again)
            if (m.action & ACT_IN_QUICKSAND) ~= 0 then
                if m.action ~= ACT_QUICKSAND_DEATH then
                    m.quicksandDepth = 0
                end
            end

            --Speed floor (BURNING SPECIAL)
            if m.action == ACT_BURNING_GROUND then
                mario_set_forward_vel(m, 0)
            end

            --regular jump replacing double jump
            if m.action == ACT_DOUBLE_JUMP then
                set_mario_action(m, ACT_JUMP, 0)
            end

            --modified jumps
            if m.action == ACT_STEEP_JUMP or m.action == ACT_JUMP or m.action == ACT_HOLD_JUMP or m.action == ACT_DOUBLE_JUMP then
                m.vel.y = m.vel.y - 1.5

                -- prevent from getting stuck on platform
                if m.marioObj.platform ~= nil then
                    m.pos.y = m.pos.y + 10
                end
            elseif m.action == ACT_TRIPLE_JUMP or m.action == ACT_SPECIAL_TRIPLE_JUMP or m.action == ACT_BACKFLIP or m.action == ACT_RIDING_SHELL_JUMP or m.action == ACT_SIDE_FLIP then
                m.vel.y = m.vel.y * 1.007

                -- prevent from getting stuck on platform
                if m.marioObj.platform ~= nil then
                    m.pos.y = m.pos.y + 10
                end
            elseif m.action == ACT_LONG_JUMP then
                m.vel.y = m.vel.y * 1.03
    
                -- prevent from getting stuck on platform
                if m.marioObj.platform ~= nil then
                    m.pos.y = m.pos.y + 10
                end
            end

            --faster dive (kinda)
            if m.action == ACT_DIVE then
                m.forwardVel = m.forwardVel + 0.5
            end

            --a ground pound jump thingy
            if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                if m.action == ACT_GROUND_POUND_LAND then
                    if (m.action & ACT_FLAG_SWIMMING) ~= 0 then return end
                    if m.pos.y == m.floorHeight then
                        set_mario_action(m, ACT_TRIPLE_JUMP, 0)
                    end
                end
            end

            -- A new way to fly
            if (m.action & ACT_FLAG_AIR) ~= 0 then
                if (m.flags & MARIO_WING_CAP) ~= 0 then
                    if m.action == ACT_SLIDE_KICK and m.prevAction == ACT_GROUND_POUND then
                        if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                            set_mario_action(m, ACT_FLYING_TRIPLE_JUMP, 0)
                            m.vel.y = m.vel.y * 0
                        end
                    end
                end
            end

            --DROP KICK BBY!!
            if (m.controller.buttonPressed & B_BUTTON) ~= 0 then
                if (m.action & ACT_FLAG_AIR) ~= 0 then
                    if m.prevAction == ACT_TRIPLE_JUMP or m.prevAction == ACT_SPECIAL_TRIPLE_JUMP or m.prevAction == ACT_BACKFLIP or m.prevAction == ACT_RIDING_SHELL_JUMP or m.prevAction == ACT_SIDE_FLIP or m.prevAction == ACT_JUMP or m.prevAction == ACT_WALL_KICK_AIR or m.prevAction == ACT_FLYING or m.prevAction == ACT_HOLD_JUMP or m.prevAction == ACT_TOP_OF_POLE_JUMP or m.prevAction == ACT_STEEP_JUMP then
                        if m.action == ACT_GROUND_POUND then
                            set_mario_action(m, ACT_SLIDE_KICK, 0)
                        end
                    end
                elseif m.action == ACT_GROUND_POUND_LAND then
                    set_mario_action(m, ACT_SLIDE_KICK, 0)
                end
            end
            if m.action == ACT_SLIDE_KICK or m.action == ACT_SLIDE_KICK_SLIDE or m.action == ACT_STEEP_JUMP or m.action == ACT_FORWARD_ROLLOUT or m.action == ACT_TOP_OF_POLE_JUMP then
                if m.action == ACT_GROUND_POUND then return end
                if (m.controller.buttonPressed & Z_TRIG) ~= 0 then
                    set_mario_action(m, ACT_GROUND_POUND, 0)
                end
            end
            if m.action == ACT_SLIDE_KICK and m.prevAction == ACT_GROUND_POUND then
                if m.actionTimer == 1 then
                    play_sound(SOUND_ACTION_FLYING_FAST, m.marioObj.header.gfx.cameraToObject)
                end
                set_mario_particle_flags(m, PARTICLE_SPARKLES, 0)
                mario_set_forward_vel(m, 60)
                m.vel.y = m.vel.y * 0
                if m.actionTimer >= 15 then
                    set_mario_action(m, ACT_FREEFALL, 0)
                end
            elseif m.action == ACT_SLIDE_KICK and m.prevAction == ACT_GROUND_POUND_LAND then
                if m.actionTimer == 1 then
                    play_sound(SOUND_ACTION_FLYING_FAST, m.marioObj.header.gfx.cameraToObject)
                end
                set_mario_particle_flags(m, PARTICLE_SPARKLES, 0)
                mario_set_forward_vel(m, 60)
            end

            --super jump kick
            if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                if (m.action & ACT_FLAG_AIR) ~= 0 then
                    if m.prevAction == ACT_TRIPLE_JUMP or m.prevAction == ACT_SPECIAL_TRIPLE_JUMP or m.prevAction == ACT_BACKFLIP or m.prevAction == ACT_RIDING_SHELL_JUMP or m.prevAction == ACT_SIDE_FLIP or m.prevAction == ACT_JUMP or m.prevAction == ACT_WALL_KICK_AIR or m.prevAction == ACT_FLYING or m.prevAction == ACT_HOLD_JUMP or m.prevAction == ACT_TOP_OF_POLE_JUMP or m.prevAction == ACT_FREEFALL or m.prevAction == ACT_SLIDE_KICK or m.prevAction == ACT_STEEP_JUMP then
                        if m.action == ACT_GROUND_POUND then
                            set_mario_action(m, ACT_JUMP_KICK, 0)
                            mario_set_forward_vel(m, 10)
                            m.vel.y = m.vel.y + 20
                        end
                    end
                end
            end
            if m.prevAction == ACT_GROUND_POUND then
                if m.action == ACT_JUMP_KICK then
                    set_mario_particle_flags(m, PARTICLE_SPARKLES, 0)
                end
            end

            --normal jump after triple
            if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
                if m.action == ACT_TRIPLE_JUMP_LAND then
                    set_mario_action(m, ACT_JUMP, 0)
                elseif m.action == ACT_METAL_WATER_JUMP_LAND or m.action == ACT_METAL_WATER_FALL_LAND or m.action == ACT_METAL_WATER_STANDING or m.action == ACT_METAL_WATER_WALKING then
                    set_mario_action(m, ACT_METAL_WATER_JUMP, 0)
                elseif m.action == ACT_HOLD_METAL_WATER_JUMP_LAND or m.action == ACT_HOLD_METAL_WATER_FALL_LAND or m.action == ACT_HOLD_METAL_WATER_STANDING or m.action == ACT_HOLD_METAL_WATER_WALKING then
                    set_mario_action(m, ACT_HOLD_METAL_WATER_JUMP, 0)
                end
            end
        end
    end
    -- hooks --
    hook_event(HOOK_MARIO_UPDATE, mario_update)

    local function on_pvp_attack(attacker, victim)
        if attacker.playerIndex == 0 then
            if myCharPlacement == _G.charSelect.character_get_current_number("Kuribo's Shoe Goomba") then
                gPlayerSyncTable[attacker.playerIndex].charMoveset = true
            else
                gPlayerSyncTable[attacker.playerIndex].charMoveset = false
            end
        end
        
        if gPlayerSyncTable[attacker.playerIndex].charMoveset then
            if victim.playerIndex ~= 0 then return end
            if attacker.action == ACT_SLIDE_KICK or attacker.action == ACT_SLIDE_KICK_SLIDE then
                victim.hurtCounter = 12
                set_mario_action(victim, ACT_HARD_FORWARD_AIR_KB, 0)
                victim.faceAngle.y = attacker.faceAngle.y
                mario_set_forward_vel(victim, 75)
            end

            if attacker.prevAction == ACT_GROUND_POUND then
                if attacker.action == ACT_JUMP_KICK then
                    victim.hurtCounter = 12
                    set_mario_action(victim, ACT_HARD_FORWARD_AIR_KB, 0)
                    victim.faceAngle.y = attacker.faceAngle.y
                    mario_set_forward_vel(victim, 75)
                end
            end
        end
    end
    
    hook_event(HOOK_ON_PVP_ATTACK, on_pvp_attack)

    local function on_interact(m, o)
        if m.playerIndex == 0 then
            if myCharPlacement == _G.charSelect.character_get_current_number("Kuribo's Shoe Goomba") then
                gPlayerSyncTable[m.playerIndex].charMoveset = true
            else
                gPlayerSyncTable[m.playerIndex].charMoveset = false
            end
        end
        
        if gPlayerSyncTable[m.playerIndex].charMoveset then
            if m.interactObj ~= nil then
                -- you're immune to spinies now. also bullies be easier to dropkick
                if obj_has_behavior_id(m.interactObj, id_bhvSpiny) ~= 0 then
                    m.hurtCounter = 0
                    if m.action == ACT_BACKWARD_GROUND_KB or m.action == ACT_FORWARD_GROUND_KB or m.action == ACT_SOFT_BACKWARD_GROUND_KB or m.action == ACT_SOFT_FORWARD_GROUND_KB or m.action == ACT_BACKWARD_AIR_KB or m.action == ACT_FORWARD_AIR_KB then
                        set_mario_action(m, ACT_JUMP, 0)
                        m.vel.y = m.vel.y + 20
                        obj_mark_for_deletion(m.interactObj)
                        spawn_mist_particles_with_sound(SOUND_OBJ_DEFAULT_DEATH)
                        m.interactObj.oInteractType = INTERACT_BOUNCE_TOP
                        m.interactObj.oBounciness       = 5
                    end
                end
                if (m.interactObj.oInteractType & INTERACT_BULLY) ~= 0 then
                    if m.action == ACT_SLIDE_KICK and m.prevAction == (ACT_GROUND_POUND or ACT_GROUND_POUND_LAND) then
                        m.interactObj.oVelY = 30
                        m.interactObj.oForwardVel = 50
                    end
                end
            end
        end
    end

    hook_event(HOOK_ON_INTERACT, on_interact)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end